#include <iostream>
#include <fstream>
#include <string>
#include <cmath>
#include <vector>

using namespace std;

#include "ekv_v26_code_r15.h"

double mse (double params[10]) {
	ifstream input ("ekv-validation.csv");
	string header;

	// header
	input >> header >> header >> header >> header;

	vector<double> tmp (params, params+10);

	double vbs, vgs, vds, id, sum = 0;
	int count = 0;
	while (true) {
		input >> vbs >> vgs >> vds >> id;
		if (!input)
			break;

		double diff = ekv_current_count(&tmp[0], 10, vgs, vds, 0, vbs) - id;
		sum += diff * diff;

		++count;
	}

	return sum / count;
}

int main (int argc, char ** argv) {
	double original[] = {0.647, .78, .93, 4.304e-05, .026, 4e6, NAN, 6.5e-08, 5e-05, 5e-05};

	cout << "original: " << mse(original) << '\n';

	return 0;
}
